package com.iconplus.smartproc.service.approval;

import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.entity.DrpRekomendasi;
import com.iconplus.smartproc.model.request.DrpRekomendasiRequest;
import com.iconplus.smartproc.model.response.DrpRekomendasiResponse;
import com.iconplus.smartproc.repository.DrpRekomendasiRepository;
import org.springframework.stereotype.Service;

@Service
public class PostDrpRekomendasiService implements BaseService<DrpRekomendasiRequest, DrpRekomendasiResponse> {

    private DrpRekomendasiRepository drpRekomendasiRepository;

    private PostDrpRekomendasiService(DrpRekomendasiRepository drpRekomendasiRepository) {
        this.drpRekomendasiRepository = drpRekomendasiRepository;
    }

    @Override
    public DrpRekomendasiResponse execute(DrpRekomendasiRequest input) {

        DrpRekomendasi drpRekomendasi = DrpRekomendasi.builder()
                .jenisPengadaanId(input.getJenisPengadaanId())
                .drpApprovalId(input.getDrpApprovalId())
                .rekomendasi(input.getRekomendasi())
                .rekomendasiDate(input.getRekomendasiDate())
                .isDelete(false)
                .build();

        var result = drpRekomendasiRepository.save(drpRekomendasi);

        return DrpRekomendasiResponse.builder()
                .id(result.getId())
                .build();
    }
}
